//************************************************************************************
//**  
//**  File name:     c:\!OPER\Gliss.c
//**  Generated by:  Flowcode v3.4.7.48
//**  Date:          Saturday, May 30, 2009 17:39:32
//**  Licence:       Professional
//**  Registered to: Leonid Mayorov
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P12F683
#define MX_EE
#define MX_EE_TYPE1
#define MX_EE_SIZE 256
#define MX_PWM
#define MX_PWM_CNT 1
#define MX_PWM_TRIS1 trisio
#define MX_PWM_1 2

//Functions
#include <system.h>
#pragma CLOCK_FREQ 31000

//Configuration data

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V3\FCD\internals.h"

//Macro function declarations
void FCM_Time();


//Variable declarations
short FCV_OUTA;
short FCV_KORR;
short FCV_ZAPAS;
short FCV_ZN;
short FCV_OUTB;
short FCV_SUM;
char FCV_SSUM;
char FCV_OUT;
short FCV_N;
short FCV_NI;
short FCV_OUTI;
char FCV_FLAG;
char FCV_A;
char FCV_SSB;




//ADC0: //Macro function declarations

void FCD_ADC0_SampleADC();
char FCD_ADC0_ReadAsByte();
short FCD_ADC0_ReadAsInt();


//PWM0: //Macro function declarations

void FCD_PWM0_Enable(char nIdx);
void FCD_PWM0_Disable(char nIdx);
void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty);
void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal);

//Supplementary defines




//ADC0: //Macro implementations


void FCD_ADC0_SampleADC()
{
	//This is from the FCD file...
	//set up ADC conversion
	char old_tris, cnt;
	#define MX_ADC_SAMP_TIME 40
	#define MX_ADC_TRIS_REG  trisio

	//find appropriate bit
	#if (0 == 0)
	  #define MX_ADC_TRIS_MSK  0x01
	  #define MX_ADC_ANS_MSK   0x01
	#endif
	#if (0 == 1)
	  #define MX_ADC_TRIS_MSK  0x02
	  #define MX_ADC_ANS_MSK   0x02
	#endif
	#if (0 == 2)
	  #define MX_ADC_TRIS_MSK  0x04
	  #define MX_ADC_ANS_MSK   0x04
	#endif
	#if (0 == 3)
	  #define MX_ADC_TRIS_MSK  0x10
	  #define MX_ADC_ANS_MSK   0x08
	#endif

	//sanity check
	#ifndef MX_ADC_TRIS_MSK
	  #pragma error ADC conversion code error - please contact technical support
	#endif

	//store old tris value, and set the i/o pin as an input
	old_tris = MX_ADC_TRIS_REG;
	MX_ADC_TRIS_REG = MX_ADC_TRIS_REG | MX_ADC_TRIS_MSK;
	ansel = 0x20 | MX_ADC_ANS_MSK;

	//turn ADC on
	adcon0 = 0x01 | (0 << 2);

	//wait the acquisition time
	cnt =0;
	while (cnt <40) cnt++;

	//begin conversion and wait until it has finished
	adcon0 = adcon0 | 0x02;
	while (adcon0 & 0x02) ;

	//restore old tris value, and reset adc registers
	trisio = old_tris;
	ansel = 0x20;
	adcon0 = 0x00;
	#undef MX_ADC_TRIS_REG
	#undef MX_ADC_TRIS_MSK
	#undef MX_ADC_SAMP_TIME
	#undef MX_ADC_ANS_MSK

}

char FCD_ADC0_ReadAsByte()
{
	//This is from the FCD file...
	return adresh;

}

short FCD_ADC0_ReadAsInt()
{
	//This is from the FCD file...
	short iRetVal;
	iRetVal = (adresh << 2);
	iRetVal += (adresl >> 6);
	return (iRetVal);

}



//PWM0: //Macro implementations


void FCD_PWM0_Enable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #else
	    #ifndef MX_PWM_CNT
	      #pragma error FCD file error (no MX_PWM_CNT)
	    #endif
	    #if (MX_PWM_CNT < 1)
	      #pragma error FCD file error (MX_PWM_CNT < 1)
	    #endif
	    #if (MX_PWM_CNT > 2)
	      #pragma error FCD file error (MX_PWM_CNT > 2)
	    #endif
	    #ifndef MX_PWM_TRIS1
	      #pragma error FCD file error (no MX_PWM_TRIS1)
	    #endif
	    #ifndef MX_PWM_1
	      #pragma error FCD file error (no MX_PWM_1)
	    #endif
	    #if (MX_PWM_CNT == 2)
	      #ifndef MX_PWM_TRIS2
	        #pragma error FCD file error (no MX_PWM_TRIS2)
	      #endif
	      #ifndef MX_PWM_2
	        #pragma error FCD file error (no MX_PWM_2)
	      #endif
	    #endif
	    #if (0 == 1)
	      #ifndef MX_PWM_TRIS1a
	        #pragma error PWM component error (using alternative, but no MX_PWM_TRIS1a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_1a
	        #pragma error PWM component error (using alternative, but no MX_PWM_1a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	    #if (0 == 2)
	      #ifndef MX_PWM_TRIS2a
	        #pragma error PWM component error (using alternative, but no MX_PWM_TRIS2a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_2a
	        #pragma error PWM component error (using alternative, but no MX_PWM_2a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	  #endif

	 #ifdef MX_PWM
	    pr2 = 255;
	    t2con = 0x04;

	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccp1con = 0x0C;

	      #if (0 == 1)
	       #ifndef MX_PWM_ALT_ERROR
	        clear_bit(MX_PWM_TRIS1a, MX_PWM_1a);
	       #endif
	      #else
	        clear_bit(MX_PWM_TRIS1, MX_PWM_1);
	      #endif
		}
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccp2con = 0x0C;
	      #if (0 == 2)
	       #ifndef MX_PWM_ALT_ERROR
	        clear_bit(MX_PWM_TRIS2a, MX_PWM_2a);
	       #endif
	      #else
	        clear_bit(MX_PWM_TRIS2, MX_PWM_2);
	      #endif
	   }
	  #endif
	 #endif

	 #ifdef MX_PWM_ALT_ERROR
	   #undef MX_PWM_ALT_ERROR
	 #endif

}

void FCD_PWM0_Disable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	 #ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccp1con = 0x00;
	    }
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccp2con = 0x00;
	    }
	  #endif
	 #endif

}

void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	 #ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccpr1l = nDuty;
	    }
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccpr2l = nDuty;
	    }
	  #endif
	 #endif

}

void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	  #ifdef MX_PWM
	    pr2 = nPeriodVal;

	    switch (nPrescalerVal)
	    {
	        case 1:
	            t2con = 0x04;
	            break;

	        case 4:
	            t2con = 0x05;
	            break;

	        case 16:
	            t2con = 0x06;
	            break;
	    }
	  #endif

}

//Macro implementations

void FCM_Time()
{
	
	//Calculation
	//Calculation:
	//  A = A + 1
	FCV_A = FCV_A + 1;
	

	//Decision
	//Decision: A > 28?
	if (FCV_A > 28)
	{
		//Calculation
		//Calculation:
		//  Flag = 1
		//  A = 0
		FCV_FLAG = 1;
		FCV_A = 0;
		

	}


}

//Supplementary implementations


void main()
{
	
	//Initialisation
	cmcon0 = 0x07;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//C Code
	//C Code:
	osccon = 0X0F;
	wdtcon=0X23;


	//Calculation
	//Calculation:
	//  N = 300
	//  Ni = 0
	FCV_N = 300;
	FCV_NI = 0;
	

	//Calculation
	//Calculation:
	//  Sum = 0
	//  SSum = 0
	FCV_SUM = 0;
	FCV_SSUM = 0;
	

	//Interrupt
	//Interrupt: Enable TMR0 Overflow
	option_reg.T0CS=1;
	option_reg.T0SE=1;
	option_reg = (option_reg & 0xF0) | 0x08;
	intcon.GIE=1;
	intcon.T0IE=1;


	//Call Component Macro
	//Call Component Macro: PWM(0)::Enable(1)
	FCD_PWM0_Enable(1);


	//Loop
	//Loop: While 1
	while (1)
	{
		//Decision
		//Decision: Flag > 0?
		if (FCV_FLAG > 0)
		{
			//Calculation
			//Calculation:
			//  Flag = 0
			FCV_FLAG = 0;
			

			//Call Component Macro
			//Call Component Macro: ADC(0)::SampleADC
			FCD_ADC0_SampleADC();


			//Call Component Macro
			//Call Component Macro: Zn=ADC(0)::ReadAsInt
			FCV_ZN = FCD_ADC0_ReadAsInt();


			//Calculation
			//Calculation:
			//  Zapas = 16384 - Sum
			FCV_ZAPAS = 16384 - FCV_SUM;
			

			//Decision
			//Decision: Zapas < Zn?
			if (FCV_ZAPAS < FCV_ZN)
			{
				//Calculation
				//Calculation:
				//  Sum = Sum - 16384
				//  SSum = SSum + 1
				FCV_SUM = FCV_SUM - 16384;
				FCV_SSUM = FCV_SSUM + 1;
				

			}


			//Decision
			//Decision: N < Ni?
			if (FCV_N < FCV_NI)
			{
				//Calculation
				//Calculation:
				//  Sum = Sum + Zn - OutB
				FCV_SUM = FCV_SUM + FCV_ZN - FCV_OUTB;
				

				//Decision
				//Decision: Sum < 0?
				if (FCV_SUM < 0)
				{
					//Calculation
					//Calculation:
					//  Sum = Sum + 16384
					//  SSum = SSum - 1
					FCV_SUM = FCV_SUM + 16384;
					FCV_SSUM = FCV_SSUM - 1;
					

				}


				//Calculation
				//Calculation:
				//  OutI = Sum + 150
				//  OutI = OutI / 300
				FCV_OUTI = FCV_SUM + 150;
				FCV_OUTI = FCV_OUTI / 300;
				

				//Correktion
				//Decision: SSum > 0?
				if (FCV_SSUM > 0)
				{
					//Calculation
					//Calculation:
					//  OutA = 54 * SSum
					//  SSB = SSum + 1
					//  SSB = SSB / 2
					FCV_OUTA = 54 * FCV_SSUM;
					FCV_SSB = FCV_SSUM + 1;
					FCV_SSB = FCV_SSB / 2;
					

					//Calculation
					//Calculation:
					//  OutI = OutA + OutI + SSB
					FCV_OUTI = FCV_OUTA + FCV_OUTI + FCV_SSB;
					

				}


			} else {
				//Calculation
				//Calculation:
				//  Ni = Ni + 1
				FCV_NI = FCV_NI + 1;
				

				//Calculation
				//Calculation:
				//  Sum = Sum + Zn
				//  OutI = Ni + 1
				//  OutI = OutI / 2
				FCV_SUM = FCV_SUM + FCV_ZN;
				FCV_OUTI = FCV_NI + 1;
				FCV_OUTI = FCV_OUTI / 2;
				

				//Calculation
				//Calculation:
				//  OutI = OutI + Sum
				//  OutI = OutI / Ni
				FCV_OUTI = FCV_OUTI + FCV_SUM;
				FCV_OUTI = FCV_OUTI / FCV_NI;
				

				//Correktion
				//Decision: SSum > 0?
				if (FCV_SSUM > 0)
				{
					//Calculation
					//Calculation:
					//  Korr = Ni + 1
					//  Korr = Korr / 2
					//  Korr = 16384 + Korr
					FCV_KORR = FCV_NI + 1;
					FCV_KORR = FCV_KORR / 2;
					FCV_KORR = 16384 + FCV_KORR;
					

					//Calculation
					//Calculation:
					//  Korr = Korr / Ni
					//  OutA = SSum * Korr
					FCV_KORR = FCV_KORR / FCV_NI;
					FCV_OUTA = FCV_SSUM * FCV_KORR;
					

					//Calculation
					//Calculation:
					//  OutI = OutI + OutA
					FCV_OUTI = FCV_OUTI + FCV_OUTA;
					

				}


			}


			//Calculation
			//Calculation:
			//  OutB = OutI
			FCV_OUTB = FCV_OUTI;
			

			//Calculation
			//Calculation:
			//  OutI = OutI + 1
			//  Out = OutI / 2
			FCV_OUTI = FCV_OUTI + 1;
			FCV_OUT = FCV_OUTI / 2;
			

			//Call Component Macro
			//Call Component Macro: PWM(0)::SetDutyCycle(1, Out)
			FCD_PWM0_SetDutyCycle(1, FCV_OUT);


		}


		//C Code
		//C Code:
		asm
		{
			clrwdt
		}



	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
	if (intcon & (1 << T0IF))
	{
		FCM_Time();
		clear_bit(intcon, T0IF);
	}


}



